/*---------------------------------------------------------------------
 * I should define add functions for setting up the panels.
--------------------------------------------------------------------- */

import javax.swing.*;          //Import swing classes.
import java.awt.*;             //Import AWT graphics classes.
import java.awt.event.*;       //Import AWT event classes.
import java.io.*;

public class Viewer extends JFrame implements ActionListener {

    Container contentPane=null;
    JPanel panelWest;
    JPanel panelCenter;
    JPanel panelWest1;
    JPanel panelWest2;
    JPanel panelWest3;
    JButton BOpen;
    JButton BSave;
    JButton BQuit;
    JButton BZoom;

    /* Define the constructor. */
    public Viewer() {
	
	//Set the layout, instantiate the panels, and add'em
	contentPane=getContentPane();
	contentPane.setLayout(new BorderLayout());
	panelWest=new JPanel();   
	panelCenter=new JPanel();
	panelCenter.setBackground(Color.white);
	contentPane.add(panelWest,"West");
	contentPane.add(panelCenter,"Center");

	//Set up the western panel.  It will contain 3 subpanels.
	panelWest.setLayout(new GridLayout(3,1));
	panelWest1=new JPanel();
	panelWest2=new JPanel();
	panelWest3=new JPanel();
	BOpen=new JButton("Open");
	BSave=new JButton("Save");
	BQuit=new JButton("Quit");
	BZoom=new JButton("Zoom");
	
	//A lot of this stuff should be reorganized as methods.  I should
	//have a method that adds buttons to panels and activates them.

	panelWest1.setLayout(new GridLayout(4,1));
	panelWest1.add(BOpen);
	panelWest1.add(BSave);
	panelWest1.add(BQuit);
	panelWest1.add(BZoom);
	panelWest.add(panelWest1);

	panelWest.add(panelWest2);
	panelWest.add(panelWest3);

	//Now activate the buttons.
	BOpen.addActionListener(this);
	BSave.addActionListener(this);

	setTitle("Viewer Application");
	setSize(800,800);
	setLNF("Motif");

	//Make the window closable.  The following is an an example
	//of Java's arcane implementation of inner classes.  Ignore for now.
	addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {
		System.exit(0);
	    }
	});

    }
    
    /* Below are the class methods. */

    //A method for changing the Look and Feel.
    public void setLNF(String someString){
	try {
	    UIManager.setLookAndFeel(someString);
	    SwingUtilities.updateComponentTreeUI(this);
	}
	catch(UnsupportedLookAndFeelException exlnf) { 
	    System.err.println(exlnf);
	}
	catch(ClassNotFoundException excnf) {
	    System.err.println(excnf);
	}
	catch(InstantiationException exie) {
	    System.err.println(exie);
	}
	catch(IllegalAccessException exiae) {
	    System.err.println(exiae);
	}
	    
    }

    //When an event occurs, it comes here for processing.
    public void actionPerformed(ActionEvent ev) {
	Object source=ev.getSource();
	if(source==BOpen) {
	    status("button 1");
	}
	else if(source==BSave) {
	    status("button 2");
	}
    }

    //A simple method for printing out to the screen.  This also illustrates
    //java's try/catch construction.
    public void status(String aString) {
	System.out.println("You pressed "+aString);
    }

    //A method for executing external commands.
    public void runJob(){
	String cmd="sh script";
	try {
	    Process p=Runtime.getRuntime().exec(cmd);
	    p.waitFor();
	}
	catch(IOException e) {
	    System.out.println(e);
	} 
	catch(InterruptedException e2) {
	} 
	
    }

    //Java offers a myriad of ways to handle I/O.  This is one of them.
    public void printIt(String someText) {
	try {
	    PrintWriter out=new PrintWriter(new FileWriter("test.txt"));
	    out.println(someText);
	    out.flush();
	    out.close();
	}
	catch (IOException e) {;}
    }

    // Good old main for standalone applications.
    public static void main(String args[]) {
	JFrame frame = new Viewer();
	frame.show();
    }

}
